(function($){  
 $.fn.productsScroller=function(options){  
	var defaults={ //default options
		scrollEasing:"easeInOutSine", //easing type
		scrollSpeed:700, //value: milliseconds
		autoShowHideButtons:true, //auto show/hide buttons
		autoScrolling:0, //value: integer
		autoScrollingSpeed:8000, //value: milliseconds
		autoScrollingEasing:"easeInOutQuad", //easing type
		autoScrollingDelay:2500 //value: milliseconds
	};
	var options=$.extend(defaults,options);
    return this.each(function(){ 
		//cache vars
		var $this=$(this);
		var $scrollerContainer=$this.children(".jPscrollerContainer");
		var $scroller=$this.children(".jPscrollerContainer").children(".jPscroller");
		var $scrollerNextButton=$this.parent(".jProductsWrapper").children(".jPscrollerNextButton");
		var $scrollerPrevButton=$this.parent(".jProductsWrapper").children(".jPscrollerPrevButton");
		var $scrollerEntry=$this.children(".jPscrollerContainer").children(".jPscroller").children();
		//set scroller width
		$scrollerContainer.css("width",999999); 
		var totalWidth=$scroller.outerWidth(true);
		$scrollerContainer.css("width",totalWidth);
		//do the scrolling
		if(totalWidth>$this.width()){ //needs scrolling
			$this.data("allowPrevClick","no").data("allowNextClick","yes");
			ClickScrolling();
			//auto scrolling
			if(options.autoScrolling>0){
				AutoScrolling();
			}
		} else {
			//no scrolling needed
			$scrollerPrevButton.add($scrollerNextButton).hide(); //hide buttons
		}
		//auto scrolling fn
		var autoScrollingCount=0;
		function AutoScrolling(){
			$scroller.delay(options.autoScrollingDelay).animate({left:-(totalWidth-$this.width())},options.autoScrollingSpeed,options.autoScrollingEasing,function(){
				$scroller.animate({left:0},options.autoScrollingSpeed,options.autoScrollingEasing,function(){
					autoScrollingCount++;
					if(options.autoScrolling>1 && options.autoScrolling!=autoScrollingCount){
						AutoScrolling();
					}
				});
			});
		}
		//click scrolling fn
		function ClickScrolling(){
			if(options.autoShowHideButtons){
				$scrollerPrevButton.hide();
			}
			$scrollerNextButton.show();
			var currentEntry;
			var currentEntryOffset=0;
			var currentEntry2;
			var currentEntryOffset2=0;
			FindNextPrev();
			$scrollerNextButton.click(function(e){ //next button
				e.preventDefault();
				var posX=$scroller.position().left;
				var diffX=totalWidth+(posX-currentEntry.outerWidth(true));
				if(!$scroller.is(":animated") && ($this.data("allowNextClick")=="yes")){
					$scrollerPrevButton.stop().show("fast");
					$this.data("allowPrevClick","yes");
					if(diffX>=$this.width()){
						if(currentEntryOffset==0){
							$scroller.stop().animate({left:"-="+currentEntry.outerWidth(true)},options.scrollSpeed,options.scrollEasing,function(){
								if(diffX==$this.width()){
									if(options.autoShowHideButtons){
										$scrollerNextButton.stop().hide("fast");
										$this.data("allowNextClick","no");
									}
								}
								currentEntry=currentEntry.next();
								FindNextPrev("prev");
							});
						}else{
							$scroller.stop().animate({left:"-="+currentEntryOffset},options.scrollSpeed,options.scrollEasing,function(){
								if(diffX==$this.width()){
									if(options.autoShowHideButtons){
										$scrollerNextButton.stop().hide("fast");
										$this.data("allowNextClick","no");
									}
								}
								currentEntryOffset=0;
								currentEntry=currentEntry.next();
								FindNextPrev("prev");
							});
						}
					}else{
						if(options.autoShowHideButtons){
							$scrollerNextButton.stop().hide("fast");
							$this.data("allowNextClick","no");
						}
						$scroller.stop().animate({left:$this.width()-totalWidth},options.scrollSpeed,options.scrollEasing,function(){
							FindNextPrev("prev");
						});
					}
				}
			});
			$scrollerPrevButton.click(function(e){ //previous button
				e.preventDefault();
				var posX=$scroller.position().left;
				var diffX=totalWidth+(posX-$this.width());
				if(!$scroller.is(":animated") && ($this.data("allowPrevClick")=="yes")){
					$scrollerNextButton.stop().show("fast");
					$this.data("allowNextClick","yes");
					if(posX+currentEntry2.outerWidth(true)<=0){
						if(currentEntryOffset2==0){
							$scroller.stop().animate({left:"+="+currentEntry2.outerWidth(true)},options.scrollSpeed,options.scrollEasing,function(){
								if(posX+currentEntry2.outerWidth(true)==0){
									if(options.autoShowHideButtons){
										$scrollerPrevButton.stop().hide("fast");
										$this.data("allowPrevClick","no");
									}
								}
								currentEntry2=currentEntry2.prev();
								FindNextPrev();
							});
						}else{
							$scroller.stop().animate({left:"+="+currentEntryOffset2},options.scrollSpeed,options.scrollEasing,function(){
								if(posX+currentEntry2.outerWidth(true)==0){
									if(options.autoShowHideButtons){
										$scrollerPrevButton.stop().hide("fast");
										$this.data("allowPrevClick","no");
									}
								}
								currentEntryOffset2=0;
								currentEntry2=currentEntry2.prev();
								FindNextPrev();
							});
						}
					}else{
						if(options.autoShowHideButtons){
							$scrollerPrevButton.stop().hide("fast");
							$this.data("allowPrevClick","no");
						}
						$scroller.stop().animate({left:0},options.scrollSpeed,options.scrollEasing,function(){
							FindNextPrev();
						});
					}
				}
			});
			function FindNextPrev(dir){
				var scrollerPosLeft=$scroller.position().left;
				$scrollerEntry.each(function(index){
					var entry=$(this);
					var entryWidth=entry.outerWidth(true);
					var entryPos=entry.position().left;
					var entryEndPos=entryPos+entryWidth;
					var w=$this.width();
					if(dir=="prev"){
						if((entryPos+scrollerPosLeft)<0){
							if((entryEndPos+scrollerPosLeft)<=0){
								currentEntry2=entry.prev();
							}else{
								currentEntry2=entry;
								currentEntryOffset2=Math.abs(entryPos+scrollerPosLeft);
							}
						}
					}else{
						if((entryPos+scrollerPosLeft)<w){
							if((entryEndPos+scrollerPosLeft)<=w){
								currentEntry=entry.next();
							}else{
								currentEntry=entry;
								currentEntryOffset=(entryEndPos+scrollerPosLeft)-w;
							}
						}
					}
				});
			}
		}
	});  
 };  
})(jQuery); 